searchData={"items":[{"type":"module","title":"TestServer","doc":"No fuzz ExUnit test server to mock third party services.\n\nFeatures:\n\n- HTTP/1\n- HTTP/2\n- WebSocket\n- Built-in TLS with self-signed certificates\n- Plug route matching","ref":"TestServer.html"},{"type":"function","title":"TestServer.add/1","doc":"","ref":"TestServer.html#add/1"},{"type":"function","title":"TestServer.add/2","doc":"Adds a route to the current test server.","ref":"TestServer.html#add/2"},{"type":"function","title":"Options - TestServer.add/2","doc":"* `:via`       - matches the route against some specific HTTP method(s) specified as an atom, like `:get` or `:put`, or a list, like `[:get, :post]`.\n  * `:match`     - an anonymous function that will be called to see if a route matches, defaults to matching with arguments of uri and `:via` option.\n  * `:to`        - a Plug or anonymous function that will be called when the route matches, defaults to return the http scheme.","ref":"TestServer.html#add/2-options"},{"type":"function","title":"TestServer.add/3","doc":"Adds a route to a test server instance.\n\nSee `add/2` for options.","ref":"TestServer.html#add/3"},{"type":"function","title":"TestServer.get_instance/0","doc":"Gets current test server instance if running.","ref":"TestServer.html#get_instance/0"},{"type":"function","title":"TestServer.plug/1","doc":"Adds a plug to the current test server.\n\nThis plug will be called for all requests before route is matched.","ref":"TestServer.html#plug/1"},{"type":"function","title":"TestServer.plug/2","doc":"Adds a route to a test server instance.\n\nSee `plug/1` for options.","ref":"TestServer.html#plug/2"},{"type":"function","title":"TestServer.start/1","doc":"Start a test server instance.\n\nThe instance will be terminated when the test case finishes.","ref":"TestServer.html#start/1"},{"type":"function","title":"Options - TestServer.start/1","doc":"* `:port`             - integer of port number, defaults to random port that can be opened;\n  * `:scheme`           - an atom for the http scheme. Defaults to `:http`;\n  * `:http_server`      - HTTP server configuration. Defaults to `{TestServer.HTTPServer.Httpd, []}`;\n  * `:tls`              - Passthru options for TLS configuration handled by the webserver;\n  * `:ipfamily`         - The IP address type to use, either `:inet` or `:inet6`. Defaults to `:inet`;","ref":"TestServer.html#start/1-options"},{"type":"function","title":"TestServer.stop/0","doc":"Shuts down the current test server.","ref":"TestServer.html#stop/0"},{"type":"function","title":"TestServer.stop/1","doc":"Shuts down a test server instance.","ref":"TestServer.html#stop/1"},{"type":"function","title":"TestServer.url/0","doc":"","ref":"TestServer.html#url/0"},{"type":"function","title":"TestServer.url/1","doc":"","ref":"TestServer.html#url/1"},{"type":"function","title":"TestServer.url/2","doc":"Produces a URL for current test server.","ref":"TestServer.html#url/2"},{"type":"function","title":"Options - TestServer.url/2","doc":"* `:host` - binary host value, it'll be added to inet for IP `127.0.0.1` and `::1`, defaults to `\"localhost\"`;","ref":"TestServer.html#url/2-options"},{"type":"function","title":"TestServer.url/3","doc":"Produces a URL for a test server instance.\n\nSee `url/2` for options.","ref":"TestServer.html#url/3"},{"type":"function","title":"TestServer.websocket_handle/1","doc":"","ref":"TestServer.html#websocket_handle/1"},{"type":"function","title":"TestServer.websocket_handle/2","doc":"Adds a message handler to a websocket instance.","ref":"TestServer.html#websocket_handle/2"},{"type":"function","title":"Options - TestServer.websocket_handle/2","doc":"* `:match`     - an anonymous function that will be called to see if a message matches, defaults to matching anything.\n  * `:to`        - an anonymous function that will be called when the message matches, defaults to returning received message.","ref":"TestServer.html#websocket_handle/2-options"},{"type":"function","title":"TestServer.websocket_info/2","doc":"Sends an message to a websocket instance.","ref":"TestServer.html#websocket_info/2"},{"type":"function","title":"TestServer.websocket_init/1","doc":"","ref":"TestServer.html#websocket_init/1"},{"type":"function","title":"TestServer.websocket_init/2","doc":"Adds a websocket route to current test server.","ref":"TestServer.html#websocket_init/2"},{"type":"function","title":"Options - TestServer.websocket_init/2","doc":"Takes the same options as `add/2`, except `:to`.","ref":"TestServer.html#websocket_init/2-options"},{"type":"function","title":"TestServer.websocket_init/3","doc":"Adds a websocket route to a test server.\n\nSee `websocket_init/2` for options.","ref":"TestServer.html#websocket_init/3"},{"type":"function","title":"TestServer.x509_suite/0","doc":"Fetches the generated x509 suite for the current test server.","ref":"TestServer.html#x509_suite/0"},{"type":"function","title":"TestServer.x509_suite/1","doc":"Fetches the generated x509 suite for a test server instance.","ref":"TestServer.html#x509_suite/1"},{"type":"type","title":"TestServer.instance/0","doc":"","ref":"TestServer.html#t:instance/0"},{"type":"type","title":"TestServer.route/0","doc":"","ref":"TestServer.html#t:route/0"},{"type":"type","title":"TestServer.stacktrace/0","doc":"","ref":"TestServer.html#t:stacktrace/0"},{"type":"type","title":"TestServer.websocket_frame/0","doc":"","ref":"TestServer.html#t:websocket_frame/0"},{"type":"type","title":"TestServer.websocket_reply/0","doc":"","ref":"TestServer.html#t:websocket_reply/0"},{"type":"type","title":"TestServer.websocket_socket/0","doc":"","ref":"TestServer.html#t:websocket_socket/0"},{"type":"type","title":"TestServer.websocket_state/0","doc":"","ref":"TestServer.html#t:websocket_state/0"},{"type":"behaviour","title":"TestServer.HTTPServer","doc":"HTTP server adapter module.","ref":"TestServer.HTTPServer.html"},{"type":"behaviour","title":"Usage - TestServer.HTTPServer","doc":"defmodule MyApp.MyHTTPServer do\n      @behaviour TestServer.HTTPServer\n\n      @impl true\n      def start(instance, port, scheme, tls_options, server_options) do\n        # ...\n      end\n\n      def stop(instance, server_options) do\n        # ...\n      end\n\n      def get_socket_pid(conn) do\n        # ...\n      end\n    end","ref":"TestServer.HTTPServer.html#module-usage"},{"type":"callback","title":"TestServer.HTTPServer.get_socket_pid/1","doc":"","ref":"TestServer.HTTPServer.html#c:get_socket_pid/1"},{"type":"callback","title":"TestServer.HTTPServer.start/5","doc":"","ref":"TestServer.HTTPServer.html#c:start/5"},{"type":"callback","title":"TestServer.HTTPServer.stop/2","doc":"","ref":"TestServer.HTTPServer.html#c:stop/2"},{"type":"type","title":"TestServer.HTTPServer.instance/0","doc":"","ref":"TestServer.HTTPServer.html#t:instance/0"},{"type":"type","title":"TestServer.HTTPServer.options/0","doc":"","ref":"TestServer.HTTPServer.html#t:options/0"},{"type":"type","title":"TestServer.HTTPServer.port_number/0","doc":"","ref":"TestServer.HTTPServer.html#t:port_number/0"},{"type":"type","title":"TestServer.HTTPServer.scheme/0","doc":"","ref":"TestServer.HTTPServer.html#t:scheme/0"},{"type":"type","title":"TestServer.HTTPServer.server_options/0","doc":"","ref":"TestServer.HTTPServer.html#t:server_options/0"},{"type":"extras","title":"TestServer","doc":"# TestServer\n\n[![Github CI](https://github.com/danschultzer/test_server/workflows/CI/badge.svg)](https://github.com/danschultzer/test_server/actions?query=workflow%3ACI)\n[![hex.pm](https://img.shields.io/hexpm/v/test_server.svg)](https://hex.pm/packages/test_server)\n\n<!-- MDOC !-->\n\nNo fuzz ExUnit test server to mock third party services.\n\nFeatures:\n\n- HTTP/1\n- HTTP/2\n- WebSocket\n- Built-in TLS with self-signed certificates\n- Plug route matching\n\n<!-- MDOC !-->","ref":"README.html"},{"type":"extras","title":"Installation - TestServer","doc":"Add `test_server` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:test_server, \"~> 0.1\", only: [:test]}\n  ]\nend\n```","ref":"README.html#installation"},{"type":"extras","title":"Usage - TestServer","doc":"```elixir\ntest \"fetch_url/0\" do\n  # The test server will autostart the current test server, if not already running\n  TestServer.add(\"/\", via: :get)\n\n  # The URL is derived from the current test server instance\n  Application.put_env(:my_app, :fetch_url, TestServer.url())\n\n  {:ok, \"HTTP\"} = MyModule.fetch_url()\nend\n```\n\nThe `TestServer.add/2` function can route a request to an anonymous function:\n\n```elixir\nTestServer.add(\"/\", to: fn conn ->\n  Plug.Conn.send_resp(conn, 200, \"success\")\nend)\n```\n\nIt can also route to a plug:\n\n```elixir\nTestServer.add(\"/\", to: MyPlug)\n```\n\nThe method to listen to can be defined with `:via`, by default it'll match any method:\n\n```elixir\nTestServer.add(\"/\", via: :post)\n```\n\nA custom match function can be set with `:match` option:\n\n```elixir\nTestServer.add(\"/\", match: fn\n  %{params: %{\"a\" => 1}} = _conn -> true\n  _conn -> false\nend)\n```\n\nWhen a route is matched it'll be removed from active routes list. The route will be triggered in the order they were added:\n\n```elixir\nTestServer.add(\"/\", via: :get, to: &Plug.Conn.send_resp(&1, 200, \"first\"))\nTestServer.add(\"/\", via: :get, to: &Plug.Conn.send_resp(&1, 200, \"second\"))\n\n{:ok, \"first\"} = fetch_request()\n{:ok, \"second\"} = fetch_request()\n```\n\nPlugs can be added to process requests before it matches any routes. If no plugs are defined `Plug.Conn.fetch_query_params/1` will be used.\n\n```elixir\nTestServer.plug(fn conn ->\n  Plug.Conn.fetch_query_params(conn)\nend)\n\nTestServer.plug(fn conn ->\n  {:ok, body, _conn} = Plug.Conn.read_body(conn, [])\n\n  %{conn | body_params: Jason.decode!(body)}\nend)\n\nTestServer.plug(MyPlug)\n```\n\n#","ref":"README.html#usage"},{"type":"extras","title":"HTTPS - TestServer","doc":"By default all routes are served as plain HTTP. HTTPS can be enabled with the `:scheme` option when starting the test server.\n\nCustom SSL certificates can also be used by defining the cowboy options:\n\n```elixir\nTestServer.start(scheme: :https, tls: [keyfile: key, certfile: cert])\n```\n\nA certificate suite will automatically generated if you don't include certificate:\n\n```elixir\n{:ok, instance} = TestServer.start(scheme: :https)\ncacerts = TestServer.x509_suite().cacerts\n```\n\n#","ref":"README.html#https"},{"type":"extras","title":"WebSocket - TestServer","doc":"WebSocket endpoint can also be set up. By default the handler will echo what was received.\n\n```elixir\ntest \"WebSocketClient\" do\n  {:ok, socket} = TestServer.websocket_init(\"/ws\")\n\n  :ok = TestServer.websocket_handle(socket)\n  :ok = TestServer.websocket_handle(socket, to: fn {:text, \"ping\"}, state -> {:reply, {:text, \"pong\"}, state} end)\n  :ok = TestServer.websocket_handle(socket, match: fn {:text, message}, _state -> message == \"hi\")\n\n  {:ok, client} = WebSocketClient.start_link(TestServer.url(\"/ws\"))\n\n  :ok = WebSocketClient.send(client, \"hello\")\n  {:ok, \"hello\"} = WebSocketClient.receive(client)\n\n  :ok = WebSocketClient.send(client, \"ping\")\n  {:ok, \"pong\"} = WebSocketClient.receive(client)\n\n  :ok = WebSocketClient.send(\"hi\")\n  {:ok, \"hi\"} = WebSocketClient.receive(client)\n\n  :ok = TestServer.websocket_info(socket, fn state -> {:reply, {:text, \"ping\"}, state} end)\n  {:ok, \"ping\"} = WebSocketClient.receive(client)\nend\n```\n\n*Note: WebSocket is not supported by the `:httpd` adapter.*\n\n#","ref":"README.html#websocket"},{"type":"extras","title":"HTTP Server Adapter - TestServer","doc":"TestServer supports `Bandit`, `Plug.Cowboy`, and `:httpd` out of the box. The HTTP adapter will be selected in this order depending which is available in the dependencies. You can also explicitly set the http server in the configuration:\n\n```elixir\nTestServer.start(http_server: {Bandit, []})\n```\n\nYou can create your own plug based HTTP Server Adapter by using the `TestServer.HTTPServer` behaviour.\n\n#","ref":"README.html#http-server-adapter"},{"type":"extras","title":"IPv6 - TestServer","doc":"Use the `:ipfamily` option to test with IPv6 when you are starting the test server:\n\n```elixir\nTestServer.start(ipfamily: :inet6)\n```\n\n<!-- MDOC !-->","ref":"README.html#ipv6"},{"type":"extras","title":"LICENSE - TestServer","doc":"(The MIT License)\n\nCopyright (c) 2022 Dan Schultzer & the Contributors\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"README.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"CHANGELOG.html"},{"type":"extras","title":"v0.1.15 (2024-02-26) - Changelog","doc":"- Validates `:http_server` option","ref":"CHANGELOG.html#v0-1-15-2024-02-26"},{"type":"extras","title":"v0.1.14 (2023-11-18) - Changelog","doc":"- Fixed compiler warning in `TestServer.Instance`","ref":"CHANGELOG.html#v0-1-14-2023-11-18"},{"type":"extras","title":"v0.1.13 (2023-08-26) - Changelog","doc":"- Fixed controlling process issues related to using the Bandit HTTP/2 adapter calling `Plug.Conn` functions in plug callbacks","ref":"CHANGELOG.html#v0-1-13-2023-08-26"},{"type":"extras","title":"v0.1.12 (2023-04-29) - Changelog","doc":"- Fixed breaking change to options in Bandit 0.7.6","ref":"CHANGELOG.html#v0-1-12-2023-04-29"},{"type":"extras","title":"v0.1.11 (2023-03-27) - Changelog","doc":"- Now uses `Plug.Conn.resp/3` instead of `Plug.Conn.send_resp/3` to prevent controlling process issue in Bandit\n- Silenced Bandit logs\n- Silence TLS notice logs","ref":"CHANGELOG.html#v0-1-11-2023-03-27"},{"type":"extras","title":"v0.1.10 (2023-02-22) - Changelog","doc":"- `:httpd` server adapter now can read request body","ref":"CHANGELOG.html#v0-1-10-2023-02-22"},{"type":"extras","title":"v0.1.9 (2023-02-18) - Changelog","doc":"- `:httpd` server adapter now parses remote ip to tuple format\n- `:httpd` server adapter now parses host from host header\n- Specifying `:host` now also binds the hostname to IPv6 loopback\n- Added `:ipfamily` option to set IP address type to use","ref":"CHANGELOG.html#v0-1-9-2023-02-18"},{"type":"extras","title":"v0.1.8 (2023-02-10) - Changelog","doc":"- Support Bandit and httpd web server\n- BREAKING CHANGE: SSL certificate settings have been moved to the `:tls` option","ref":"CHANGELOG.html#v0-1-8-2023-02-10"},{"type":"extras","title":"v0.1.7 (2022-10-06) - Changelog","doc":"- The specified port is checked to ensure is in valid range","ref":"CHANGELOG.html#v0-1-7-2022-10-06"},{"type":"extras","title":"v0.1.6 (2022-09-22) - Changelog","doc":"- Added suspended routes and web socket handlers to error messages","ref":"CHANGELOG.html#v0-1-6-2022-09-22"},{"type":"extras","title":"v0.1.5 (2022-09-13) - Changelog","doc":"- `TestServer.websocket_info/2` now takes the callback function as second argument","ref":"CHANGELOG.html#v0-1-5-2022-09-13"},{"type":"extras","title":"v0.1.4 (2022-09-13) - Changelog","doc":"- WebSocket support","ref":"CHANGELOG.html#v0-1-4-2022-09-13"},{"type":"extras","title":"v0.1.3 (2022-09-12) - Changelog","doc":"- Improved multi-instance handling\n- Support for pre-match plugs","ref":"CHANGELOG.html#v0-1-3-2022-09-12"},{"type":"extras","title":"v0.1.2 (2022-09-12) - Changelog","doc":"- Better formatting of errors","ref":"CHANGELOG.html#v0-1-2-2022-09-12"},{"type":"extras","title":"v0.1.1 (2022-09-11) - Changelog","doc":"- `TestServer.url/2` no longer autostarts the test server","ref":"CHANGELOG.html#v0-1-1-2022-09-11"},{"type":"extras","title":"v0.1.0 (2022-09-11) - Changelog","doc":"- Initial release","ref":"CHANGELOG.html#v0-1-0-2022-09-11"}],"content_type":"text/markdown"}